/**
 * Created by AlexanderC on 6/15/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AbstractDriver = undefined;

var _deepCore = require('deep-core');

var _deepCore2 = _interopRequireDefault(_deepCore);

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Abstract log driver
 */
class AbstractDriver extends _deepCore2.default.OOP.Interface {
  constructor() {
    super(['log']);
  }

  /**
   * @param {*} context
   * @returns {String}
   */
  static plainifyContext(context) {
    let type = typeof context;
    var plainContext;

    if (type === 'object') {
      plainContext = JSON.stringify(context);
    } else if (context instanceof Object) {
      plainContext = `${type}: ${context.toString()}`;
    } else {
      plainContext = context.toString();
    }

    return plainContext;
  }

  /**
   * @returns {String}
   */
  static get datetime() {
    return new Date().toISOString();
  }

  /**
   * @returns {String}
   */
  static get timeString() {
    return new Date().toTimeString();
  }

  /**
   * @param {String} str
   * @returns {String}
   */
  static _md5(str) {
    return _crypto2.default.createHash('md5').update(str).digest('hex');
  }
}
exports.AbstractDriver = AbstractDriver;