/**
 * Created by mgoria on 03/03/16.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FailedToReceiveSqsMessageException = undefined;

var _LogDriverException = require('./LogDriverException');

/**
 * Thrown when failed to receive sqs messages
 */
class FailedToReceiveSqsMessageException extends _LogDriverException.LogDriverException {
  /**
   * @param {String} sqsQueueUrl
   * @param {Object} error
   */
  constructor(sqsQueueUrl, error) {
    super(`Failed to receive messages from "${sqsQueueUrl}" SQS queue. ${error}`);
  }
}
exports.FailedToReceiveSqsMessageException = FailedToReceiveSqsMessageException;