/**
 * Created by mgoria on 1/20/16.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FailedToSendBatchSqsMessageException = undefined;

var _LogDriverException = require('./LogDriverException');

/**
 * Thrown when failed to send sqs message
 */
class FailedToSendBatchSqsMessageException extends _LogDriverException.LogDriverException {
  /**
   * @param {String} sqsQueueUrl
   * @param {Object} error
   */
  constructor(sqsQueueUrl, error) {
    super(`Failed to send batch messages to ${sqsQueueUrl} SQS queue. ${error}`);
  }
}
exports.FailedToSendBatchSqsMessageException = FailedToSendBatchSqsMessageException;