/**
 * Created by mgoria on 1/20/16.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FailedToSendSqsMessageException = undefined;

var _LogDriverException = require('./LogDriverException');

/**
 * Thrown when failed to send sqs message
 */
class FailedToSendSqsMessageException extends _LogDriverException.LogDriverException {
  /**
   * @param {String} sqsQueueUrl
   * @param {String} message
   * @param {Object} error
   */
  constructor(sqsQueueUrl, message, error) {
    super(`Failed to send "${message}" message to ${sqsQueueUrl} SQS queue. ${error}`);
  }
}
exports.FailedToSendSqsMessageException = FailedToSendSqsMessageException;