/**
 * Created by mgoria on 1/21/16.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InvalidSqsQueueUrlException = undefined;

var _LogDriverException = require('./LogDriverException');

/**
 * Thrown when SQS queue url is invalid
 */
class InvalidSqsQueueUrlException extends _LogDriverException.LogDriverException {
  /**
   * @param {String} sqsQueueUrl
   * @param {Object|String} error
   */
  constructor(sqsQueueUrl, error) {
    super(`Invalid SQS queue url "${sqsQueueUrl}". ${error}`);
  }
}
exports.InvalidSqsQueueUrlException = InvalidSqsQueueUrlException;