/**
 * Created by CCristi <ccovali@mitocgroup.com> on 4/19/16.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EventFactory = undefined;

var _FrameworkEvent = require('./FrameworkEvent');

var _FrontendEvent = require('./FrontendEvent');

var _AbstractEvent = require('./AbstractEvent');

var _UnknownRumEventException = require('../Exception/UnknownRumEventException');

/**
 * Event Factory
 */
class EventFactory {
  /**
   * @param {Object} kernel
   * @param {Object} rawData
   * @returns {EventClass}
   */
  static create(kernel, rawData) {
    let EventClass = null;

    // @note - For the time being event type is guessed by event.service
    // (it'll be changed once we'll have other types of events)
    if (rawData.service && _AbstractEvent.AbstractEvent.SERVICES.indexOf(rawData.service) !== -1) {
      EventClass = _FrameworkEvent.FrameworkEvent;
    } else if (rawData.engine) {
      EventClass = _FrontendEvent.FrontendEvent;
    } else {
      throw new _UnknownRumEventException.UnknownRumEventException(rawData);
    }

    return new EventClass(kernel, rawData);
  }
}
exports.EventFactory = EventFactory;