/**
 * Created by mgoria on 1/29/16.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FrameworkEvent = undefined;

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

var _AbstractEvent = require('./AbstractEvent');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Framework event level
 */
class FrameworkEvent extends _AbstractEvent.AbstractEvent {
  /**
   * @param {Array} args
   */
  constructor(...args) {
    super(...args);
  }

  /**
   * @returns {String}
   */
  getEventLevel() {
    return _AbstractEvent.AbstractEvent.FRAMEWORK_EVENT_LEVEL;
  }

  /**
   * @returns {Object}
   */
  toJSON() {
    return this._data;
  }

  /**
   * @returns {Object}
   */
  getValidationSchema() {
    return _joi2.default.object().keys({
      depthLevel: _joi2.default.number().integer().optional(),
      eventLevel: _joi2.default.string().required().allow([_AbstractEvent.AbstractEvent.FRAMEWORK_EVENT_LEVEL]),
      service: _joi2.default.string().required().allow(_AbstractEvent.AbstractEvent.SERVICES),
      resourceType: _joi2.default.string().required().allow(_AbstractEvent.AbstractEvent.RESOURCE_TYPES),
      resourceId: _joi2.default.string().required(),
      eventName: _joi2.default.string().required(),
      eventId: _joi2.default.string().alphanum().optional(),
      time: _joi2.default.number().integer().required(),
      context: _joi2.default.string().required().allow(_AbstractEvent.AbstractEvent.CONTEXTS),
      memoryUsage: _joi2.default.object().unknown().optional().default({}),
      payload: _joi2.default.object().unknown().optional().default({}),
      metadata: _joi2.default.object().unknown().optional().default({}),
      environment: _joi2.default.object().unknown().optional().default({}),
      requestId: _joi2.default.string(),
      mainRequestId: _joi2.default.string().optional(),
      identityId: _joi2.default.string().required()
    });
  }
}
exports.FrameworkEvent = FrameworkEvent;